// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package favorites

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/members/members_models"
)

// NewPostFavoriteParams creates a new PostFavoriteParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPostFavoriteParams() *PostFavoriteParams {
	return &PostFavoriteParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPostFavoriteParamsWithTimeout creates a new PostFavoriteParams object
// with the ability to set a timeout on a request.
func NewPostFavoriteParamsWithTimeout(timeout time.Duration) *PostFavoriteParams {
	return &PostFavoriteParams{
		timeout: timeout,
	}
}

// NewPostFavoriteParamsWithContext creates a new PostFavoriteParams object
// with the ability to set a context for a request.
func NewPostFavoriteParamsWithContext(ctx context.Context) *PostFavoriteParams {
	return &PostFavoriteParams{
		Context: ctx,
	}
}

// NewPostFavoriteParamsWithHTTPClient creates a new PostFavoriteParams object
// with the ability to set a custom HTTPClient for a request.
func NewPostFavoriteParamsWithHTTPClient(client *http.Client) *PostFavoriteParams {
	return &PostFavoriteParams{
		HTTPClient: client,
	}
}

/*
PostFavoriteParams contains all the parameters to send to the API endpoint

	for the post favorite operation.

	Typically these are written to a http.Request.
*/
type PostFavoriteParams struct {

	/* FavoriteRequest.

	   An array of new Favorite records
	*/
	FavoriteRequest *members_models.FavoriteRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the post favorite params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostFavoriteParams) WithDefaults() *PostFavoriteParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the post favorite params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostFavoriteParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the post favorite params
func (o *PostFavoriteParams) WithTimeout(timeout time.Duration) *PostFavoriteParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the post favorite params
func (o *PostFavoriteParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the post favorite params
func (o *PostFavoriteParams) WithContext(ctx context.Context) *PostFavoriteParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the post favorite params
func (o *PostFavoriteParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the post favorite params
func (o *PostFavoriteParams) WithHTTPClient(client *http.Client) *PostFavoriteParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the post favorite params
func (o *PostFavoriteParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFavoriteRequest adds the favoriteRequest to the post favorite params
func (o *PostFavoriteParams) WithFavoriteRequest(favoriteRequest *members_models.FavoriteRequest) *PostFavoriteParams {
	o.SetFavoriteRequest(favoriteRequest)
	return o
}

// SetFavoriteRequest adds the favoriteRequest to the post favorite params
func (o *PostFavoriteParams) SetFavoriteRequest(favoriteRequest *members_models.FavoriteRequest) {
	o.FavoriteRequest = favoriteRequest
}

// WriteToRequest writes these params to a swagger request
func (o *PostFavoriteParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.FavoriteRequest != nil {
		if err := r.SetBodyParam(o.FavoriteRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
