// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package invoices

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/members/members_models"
)

// NewPostInvoiceParams creates a new PostInvoiceParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPostInvoiceParams() *PostInvoiceParams {
	return &PostInvoiceParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPostInvoiceParamsWithTimeout creates a new PostInvoiceParams object
// with the ability to set a timeout on a request.
func NewPostInvoiceParamsWithTimeout(timeout time.Duration) *PostInvoiceParams {
	return &PostInvoiceParams{
		timeout: timeout,
	}
}

// NewPostInvoiceParamsWithContext creates a new PostInvoiceParams object
// with the ability to set a context for a request.
func NewPostInvoiceParamsWithContext(ctx context.Context) *PostInvoiceParams {
	return &PostInvoiceParams{
		Context: ctx,
	}
}

// NewPostInvoiceParamsWithHTTPClient creates a new PostInvoiceParams object
// with the ability to set a custom HTTPClient for a request.
func NewPostInvoiceParamsWithHTTPClient(client *http.Client) *PostInvoiceParams {
	return &PostInvoiceParams{
		HTTPClient: client,
	}
}

/*
PostInvoiceParams contains all the parameters to send to the API endpoint

	for the post invoice operation.

	Typically these are written to a http.Request.
*/
type PostInvoiceParams struct {

	/* InvoiceRequest.

	   An array of new Invoice records
	*/
	InvoiceRequest *members_models.InvoiceRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the post invoice params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostInvoiceParams) WithDefaults() *PostInvoiceParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the post invoice params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostInvoiceParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the post invoice params
func (o *PostInvoiceParams) WithTimeout(timeout time.Duration) *PostInvoiceParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the post invoice params
func (o *PostInvoiceParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the post invoice params
func (o *PostInvoiceParams) WithContext(ctx context.Context) *PostInvoiceParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the post invoice params
func (o *PostInvoiceParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the post invoice params
func (o *PostInvoiceParams) WithHTTPClient(client *http.Client) *PostInvoiceParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the post invoice params
func (o *PostInvoiceParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithInvoiceRequest adds the invoiceRequest to the post invoice params
func (o *PostInvoiceParams) WithInvoiceRequest(invoiceRequest *members_models.InvoiceRequest) *PostInvoiceParams {
	o.SetInvoiceRequest(invoiceRequest)
	return o
}

// SetInvoiceRequest adds the invoiceRequest to the post invoice params
func (o *PostInvoiceParams) SetInvoiceRequest(invoiceRequest *members_models.InvoiceRequest) {
	o.InvoiceRequest = invoiceRequest
}

// WriteToRequest writes these params to a swagger request
func (o *PostInvoiceParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.InvoiceRequest != nil {
		if err := r.SetBodyParam(o.InvoiceRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
