// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package payment_methods

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/members/members_models"
)

// NewPostPaymentMethodParams creates a new PostPaymentMethodParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPostPaymentMethodParams() *PostPaymentMethodParams {
	return &PostPaymentMethodParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPostPaymentMethodParamsWithTimeout creates a new PostPaymentMethodParams object
// with the ability to set a timeout on a request.
func NewPostPaymentMethodParamsWithTimeout(timeout time.Duration) *PostPaymentMethodParams {
	return &PostPaymentMethodParams{
		timeout: timeout,
	}
}

// NewPostPaymentMethodParamsWithContext creates a new PostPaymentMethodParams object
// with the ability to set a context for a request.
func NewPostPaymentMethodParamsWithContext(ctx context.Context) *PostPaymentMethodParams {
	return &PostPaymentMethodParams{
		Context: ctx,
	}
}

// NewPostPaymentMethodParamsWithHTTPClient creates a new PostPaymentMethodParams object
// with the ability to set a custom HTTPClient for a request.
func NewPostPaymentMethodParamsWithHTTPClient(client *http.Client) *PostPaymentMethodParams {
	return &PostPaymentMethodParams{
		HTTPClient: client,
	}
}

/*
PostPaymentMethodParams contains all the parameters to send to the API endpoint

	for the post payment method operation.

	Typically these are written to a http.Request.
*/
type PostPaymentMethodParams struct {

	/* PaymentmethodRequest.

	   An array of new PaymentMethod records
	*/
	PaymentmethodRequest *members_models.PaymentMethodRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the post payment method params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostPaymentMethodParams) WithDefaults() *PostPaymentMethodParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the post payment method params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostPaymentMethodParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the post payment method params
func (o *PostPaymentMethodParams) WithTimeout(timeout time.Duration) *PostPaymentMethodParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the post payment method params
func (o *PostPaymentMethodParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the post payment method params
func (o *PostPaymentMethodParams) WithContext(ctx context.Context) *PostPaymentMethodParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the post payment method params
func (o *PostPaymentMethodParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the post payment method params
func (o *PostPaymentMethodParams) WithHTTPClient(client *http.Client) *PostPaymentMethodParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the post payment method params
func (o *PostPaymentMethodParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithPaymentmethodRequest adds the paymentmethodRequest to the post payment method params
func (o *PostPaymentMethodParams) WithPaymentmethodRequest(paymentmethodRequest *members_models.PaymentMethodRequest) *PostPaymentMethodParams {
	o.SetPaymentmethodRequest(paymentmethodRequest)
	return o
}

// SetPaymentmethodRequest adds the paymentmethodRequest to the post payment method params
func (o *PostPaymentMethodParams) SetPaymentmethodRequest(paymentmethodRequest *members_models.PaymentMethodRequest) {
	o.PaymentmethodRequest = paymentmethodRequest
}

// WriteToRequest writes these params to a swagger request
func (o *PostPaymentMethodParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.PaymentmethodRequest != nil {
		if err := r.SetBodyParam(o.PaymentmethodRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
