// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package transactions

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/members/members_models"
)

// NewPostTransactionParams creates a new PostTransactionParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPostTransactionParams() *PostTransactionParams {
	return &PostTransactionParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPostTransactionParamsWithTimeout creates a new PostTransactionParams object
// with the ability to set a timeout on a request.
func NewPostTransactionParamsWithTimeout(timeout time.Duration) *PostTransactionParams {
	return &PostTransactionParams{
		timeout: timeout,
	}
}

// NewPostTransactionParamsWithContext creates a new PostTransactionParams object
// with the ability to set a context for a request.
func NewPostTransactionParamsWithContext(ctx context.Context) *PostTransactionParams {
	return &PostTransactionParams{
		Context: ctx,
	}
}

// NewPostTransactionParamsWithHTTPClient creates a new PostTransactionParams object
// with the ability to set a custom HTTPClient for a request.
func NewPostTransactionParamsWithHTTPClient(client *http.Client) *PostTransactionParams {
	return &PostTransactionParams{
		HTTPClient: client,
	}
}

/*
PostTransactionParams contains all the parameters to send to the API endpoint

	for the post transaction operation.

	Typically these are written to a http.Request.
*/
type PostTransactionParams struct {

	/* TransactionRequest.

	   An array of new Transaction records
	*/
	TransactionRequest *members_models.TransactionRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the post transaction params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostTransactionParams) WithDefaults() *PostTransactionParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the post transaction params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostTransactionParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the post transaction params
func (o *PostTransactionParams) WithTimeout(timeout time.Duration) *PostTransactionParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the post transaction params
func (o *PostTransactionParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the post transaction params
func (o *PostTransactionParams) WithContext(ctx context.Context) *PostTransactionParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the post transaction params
func (o *PostTransactionParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the post transaction params
func (o *PostTransactionParams) WithHTTPClient(client *http.Client) *PostTransactionParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the post transaction params
func (o *PostTransactionParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithTransactionRequest adds the transactionRequest to the post transaction params
func (o *PostTransactionParams) WithTransactionRequest(transactionRequest *members_models.TransactionRequest) *PostTransactionParams {
	o.SetTransactionRequest(transactionRequest)
	return o
}

// SetTransactionRequest adds the transactionRequest to the post transaction params
func (o *PostTransactionParams) SetTransactionRequest(transactionRequest *members_models.TransactionRequest) {
	o.TransactionRequest = transactionRequest
}

// WriteToRequest writes these params to a swagger request
func (o *PostTransactionParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.TransactionRequest != nil {
		if err := r.SetBodyParam(o.TransactionRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
