// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package users

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/members/members_models"
)

// PostUsersReader is a Reader for the PostUsers structure.
type PostUsersReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PostUsersReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPostUsersOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPostUsersUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPostUsersForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPostUsersNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPostUsersUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPostUsersInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewPostUsersOK creates a PostUsersOK with default headers values
func NewPostUsersOK() *PostUsersOK {
	return &PostUsersOK{}
}

/*
PostUsersOK describes a response with status code 200, with default header values.

Response with User objects
*/
type PostUsersOK struct {
	Payload *members_models.UserResponse
}

// IsSuccess returns true when this post users o k response has a 2xx status code
func (o *PostUsersOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this post users o k response has a 3xx status code
func (o *PostUsersOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post users o k response has a 4xx status code
func (o *PostUsersOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this post users o k response has a 5xx status code
func (o *PostUsersOK) IsServerError() bool {
	return false
}

// IsCode returns true when this post users o k response a status code equal to that given
func (o *PostUsersOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the post users o k response
func (o *PostUsersOK) Code() int {
	return 200
}

func (o *PostUsersOK) Error() string {
	return fmt.Sprintf("[POST /users][%d] postUsersOK  %+v", 200, o.Payload)
}

func (o *PostUsersOK) String() string {
	return fmt.Sprintf("[POST /users][%d] postUsersOK  %+v", 200, o.Payload)
}

func (o *PostUsersOK) GetPayload() *members_models.UserResponse {
	return o.Payload
}

func (o *PostUsersOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(members_models.UserResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostUsersUnauthorized creates a PostUsersUnauthorized with default headers values
func NewPostUsersUnauthorized() *PostUsersUnauthorized {
	return &PostUsersUnauthorized{}
}

/*
PostUsersUnauthorized describes a response with status code 401, with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type PostUsersUnauthorized struct {
	Payload *members_models.Error
}

// IsSuccess returns true when this post users unauthorized response has a 2xx status code
func (o *PostUsersUnauthorized) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post users unauthorized response has a 3xx status code
func (o *PostUsersUnauthorized) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post users unauthorized response has a 4xx status code
func (o *PostUsersUnauthorized) IsClientError() bool {
	return true
}

// IsServerError returns true when this post users unauthorized response has a 5xx status code
func (o *PostUsersUnauthorized) IsServerError() bool {
	return false
}

// IsCode returns true when this post users unauthorized response a status code equal to that given
func (o *PostUsersUnauthorized) IsCode(code int) bool {
	return code == 401
}

// Code gets the status code for the post users unauthorized response
func (o *PostUsersUnauthorized) Code() int {
	return 401
}

func (o *PostUsersUnauthorized) Error() string {
	return fmt.Sprintf("[POST /users][%d] postUsersUnauthorized  %+v", 401, o.Payload)
}

func (o *PostUsersUnauthorized) String() string {
	return fmt.Sprintf("[POST /users][%d] postUsersUnauthorized  %+v", 401, o.Payload)
}

func (o *PostUsersUnauthorized) GetPayload() *members_models.Error {
	return o.Payload
}

func (o *PostUsersUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(members_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostUsersForbidden creates a PostUsersForbidden with default headers values
func NewPostUsersForbidden() *PostUsersForbidden {
	return &PostUsersForbidden{}
}

/*
PostUsersForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type PostUsersForbidden struct {
	AccessControlAllowOrigin string

	Payload *members_models.Error
}

// IsSuccess returns true when this post users forbidden response has a 2xx status code
func (o *PostUsersForbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post users forbidden response has a 3xx status code
func (o *PostUsersForbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post users forbidden response has a 4xx status code
func (o *PostUsersForbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this post users forbidden response has a 5xx status code
func (o *PostUsersForbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this post users forbidden response a status code equal to that given
func (o *PostUsersForbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the post users forbidden response
func (o *PostUsersForbidden) Code() int {
	return 403
}

func (o *PostUsersForbidden) Error() string {
	return fmt.Sprintf("[POST /users][%d] postUsersForbidden  %+v", 403, o.Payload)
}

func (o *PostUsersForbidden) String() string {
	return fmt.Sprintf("[POST /users][%d] postUsersForbidden  %+v", 403, o.Payload)
}

func (o *PostUsersForbidden) GetPayload() *members_models.Error {
	return o.Payload
}

func (o *PostUsersForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(members_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostUsersNotFound creates a PostUsersNotFound with default headers values
func NewPostUsersNotFound() *PostUsersNotFound {
	return &PostUsersNotFound{}
}

/*
PostUsersNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type PostUsersNotFound struct {
	Payload *members_models.Error
}

// IsSuccess returns true when this post users not found response has a 2xx status code
func (o *PostUsersNotFound) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post users not found response has a 3xx status code
func (o *PostUsersNotFound) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post users not found response has a 4xx status code
func (o *PostUsersNotFound) IsClientError() bool {
	return true
}

// IsServerError returns true when this post users not found response has a 5xx status code
func (o *PostUsersNotFound) IsServerError() bool {
	return false
}

// IsCode returns true when this post users not found response a status code equal to that given
func (o *PostUsersNotFound) IsCode(code int) bool {
	return code == 404
}

// Code gets the status code for the post users not found response
func (o *PostUsersNotFound) Code() int {
	return 404
}

func (o *PostUsersNotFound) Error() string {
	return fmt.Sprintf("[POST /users][%d] postUsersNotFound  %+v", 404, o.Payload)
}

func (o *PostUsersNotFound) String() string {
	return fmt.Sprintf("[POST /users][%d] postUsersNotFound  %+v", 404, o.Payload)
}

func (o *PostUsersNotFound) GetPayload() *members_models.Error {
	return o.Payload
}

func (o *PostUsersNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(members_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostUsersUnprocessableEntity creates a PostUsersUnprocessableEntity with default headers values
func NewPostUsersUnprocessableEntity() *PostUsersUnprocessableEntity {
	return &PostUsersUnprocessableEntity{}
}

/*
PostUsersUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PostUsersUnprocessableEntity struct {
	Payload *members_models.Error
}

// IsSuccess returns true when this post users unprocessable entity response has a 2xx status code
func (o *PostUsersUnprocessableEntity) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post users unprocessable entity response has a 3xx status code
func (o *PostUsersUnprocessableEntity) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post users unprocessable entity response has a 4xx status code
func (o *PostUsersUnprocessableEntity) IsClientError() bool {
	return true
}

// IsServerError returns true when this post users unprocessable entity response has a 5xx status code
func (o *PostUsersUnprocessableEntity) IsServerError() bool {
	return false
}

// IsCode returns true when this post users unprocessable entity response a status code equal to that given
func (o *PostUsersUnprocessableEntity) IsCode(code int) bool {
	return code == 422
}

// Code gets the status code for the post users unprocessable entity response
func (o *PostUsersUnprocessableEntity) Code() int {
	return 422
}

func (o *PostUsersUnprocessableEntity) Error() string {
	return fmt.Sprintf("[POST /users][%d] postUsersUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PostUsersUnprocessableEntity) String() string {
	return fmt.Sprintf("[POST /users][%d] postUsersUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PostUsersUnprocessableEntity) GetPayload() *members_models.Error {
	return o.Payload
}

func (o *PostUsersUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(members_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostUsersInternalServerError creates a PostUsersInternalServerError with default headers values
func NewPostUsersInternalServerError() *PostUsersInternalServerError {
	return &PostUsersInternalServerError{}
}

/*
PostUsersInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type PostUsersInternalServerError struct {
	Payload *members_models.Error
}

// IsSuccess returns true when this post users internal server error response has a 2xx status code
func (o *PostUsersInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post users internal server error response has a 3xx status code
func (o *PostUsersInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post users internal server error response has a 4xx status code
func (o *PostUsersInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this post users internal server error response has a 5xx status code
func (o *PostUsersInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this post users internal server error response a status code equal to that given
func (o *PostUsersInternalServerError) IsCode(code int) bool {
	return code == 500
}

// Code gets the status code for the post users internal server error response
func (o *PostUsersInternalServerError) Code() int {
	return 500
}

func (o *PostUsersInternalServerError) Error() string {
	return fmt.Sprintf("[POST /users][%d] postUsersInternalServerError  %+v", 500, o.Payload)
}

func (o *PostUsersInternalServerError) String() string {
	return fmt.Sprintf("[POST /users][%d] postUsersInternalServerError  %+v", 500, o.Payload)
}

func (o *PostUsersInternalServerError) GetPayload() *members_models.Error {
	return o.Payload
}

func (o *PostUsersInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(members_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
